<?php include 'inc/header.php';?>

<?php
/*
 * Colour swabs
 */
function adjustBrightness($hex, $steps) {
    // Steps should be between -255 and 255. Negative = darker, positive = lighter
    $steps = max(-255, min(255, $steps));

    // Normalize into a six character long hex string
    $hex = str_replace('#', '', $hex);
    if (strlen($hex) == 3) {
        $hex = str_repeat(substr($hex,0,1), 2).str_repeat(substr($hex,1,1), 2).str_repeat(substr($hex,2,1), 2);
    }

    // Split into three parts: R, G and B
    $color_parts = str_split($hex, 2);
    $return = '#';

    foreach ($color_parts as $color) {
        $color   = hexdec($color); // Convert to decimal
        $color   = max(0,min(255,$color + $steps)); // Adjust color
        $return .= str_pad(dechex($color), 2, '0', STR_PAD_LEFT); // Make two char hex code
    }

    return $return;
}




// GET VAR AND CHECK IF FUNCTION EXISTS

$tools = new Core_Tools();

$tool = $_REQUEST['func'];

$tool_url = str_replace('-', '_', $tool);




if (method_exists($tools, $tool_url)) {

$core_tool = call_user_func(array($tools, $tool_url));

echo '<div class="tool_form_container" style="background: linear-gradient(45deg, '.adjustBrightness($core_tool['COLOUR'], '-50').' 25%, '.$core_tool['COLOUR'].' 100%) !important" colour="'.$core_tool['COLOUR'].'"><div class="toolpg">';



if (empty($_POST)) { 



echo '<h1>' . $core_tool['TITLE'] . '</h1>';



echo '<p>' . $core_tool['DESCRIPTION'] . '</p>';



echo loading_animation();

$url_field = '
<label class="col-sm-7 audit_input_wrap" for="audit_input_url audit_url_wrap">
    <i class="fa fa-link" aria-hidden="true"></i>
    <input name="audit_input_url" id="audit_input_url" type="url" required class="audit_input_url" placeholder="Website URL"/>
</label>';

$keyword_field = '
<label class="col-sm-7 audit_input_wrap" for="audit_input_keyword audit_url_wrap">
    <i class="fas fa-pencil-alt"></i>
    <input name="audit_input_keyword" id="audit_input_keyword" type="text" required class="audit_input_url" placeholder="Target Keyword"/>
</label>';

if ($core_tool['INPUT_FIELDS'] == 'STANDARD_KEYWORD') {
    $fields = $url_field . $keyword_field;
}

if ($core_tool['INPUT_FIELDS'] == 'STANDARD') {
    $fields = $url_field;
}

if ($core_tool['INPUT_FIELDS'] == 'NONE') {
    $fields = '<input type="hidden" id="no_fields" name="no_fields" value="TRUE"/>';
}

?>





<div class="audit_form_container">

    <form method="post" id="audit" name="audit" class="audit_form <?=$core_tool['INPUT_FIELDS'];?>">

        <?= $fields; ?>

        <input type="hidden" id="audit_function" name="audit_function" value="<?= $core_tool['TOOL_FUNCTION']; ?>"/>

        <input type="submit" style="background: <?= adjustBrightness($core_tool['COLOUR'], '-50'); ?>" class="audit_submit btn col-sm-5" value="LET'S GO!"/>

    </form>
    <div id="tri" style="border-top-color: <?= adjustBrightness($core_tool['COLOUR'], '-40'); ?>"></div>
</div>

</div></div>

         

<div class="statcontent formresponse">

<div class="container">

<!-- FORM RESPONSE WILL GO HERE -->     

</div>     

</div>  







<?php

related_tools($core_tool['TOOL_CATEGORY'], $core_tool['TITLE']);

if (!empty($core_tool['MAIN_CONTENT'])) {

echo '<div class="statcontent"><div class="container">';

echo $core_tool['MAIN_CONTENT'];

echo '</div></div>';

}
?>

         

        

<?php

}



echo '</div>';

    

} else {

    echo function_404();

}

?>

<?php 

include 'inc/footer.php';

?>